/**
* Filename: EventDispatcher.java (in org.openbandy.event)
* This file is part of the BandyBasics project.
*
* www.openbandy.org
*/

package org.openbandy.event;

import java.util.Enumeration;
import java.util.Hashtable;

/**
 * TODO describe purpose and usage
 *
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 *
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 0.5
 * 
 */
public class EventDispatcher {
    
    /* registered event sinks, no duplicates: sink -> sink */
    private Hashtable registeredEventSinks;
    
    /* registered filters, no duplicates: sink -> filter */
    private Hashtable registeredEventFilters;
    
    /* short class name of event type dispatched */
    private String eventShortClassName;
    
    /* Constructor */
    public EventDispatcher(String eventShortClassName){
        this.eventShortClassName = eventShortClassName;
        this.registeredEventSinks = new Hashtable();
        this.registeredEventFilters = new Hashtable();
    }
    
    
    //TODO remove dev code
    public Hashtable getRegisteredEventSinks(){
        return registeredEventSinks;
    }
    
    /* *************** Getter and Setter ***************** */
    
    public String getEventShortClassName(){
        return eventShortClassName;
    }
    
    public void addSink(EventSink eventSink, EventFilter filter){
        /* avoid duplicate entries */
        registeredEventSinks.put(eventSink, eventSink);
        if(filter != null){
            registeredEventFilters.put(eventSink, filter);
        }
    }
    
    public boolean removeSink(EventSink eventSink){
        registeredEventFilters.remove(eventSink);
        return (registeredEventSinks.remove(eventSink) != null);
    }
    
    public boolean isEmpty(){
        return (registeredEventSinks.size() == 0);
    }
    
    
    /* *************** Worker Method ***************** */
    
    public void dispatchEvent(Event event){
        EventDispatcherThread eventDispatcherThread = new EventDispatcherThread(event, registeredEventSinks.elements(), registeredEventFilters);
        eventDispatcherThread.start();
    }
    
    public void informLostSource(){
        Enumeration elements = registeredEventSinks.elements();
        while(elements.hasMoreElements()){
            EventSink sink = (EventSink)elements.nextElement();
            sink.lostEventSource(eventShortClassName);
        }
    }
}
