/**
* Filename: PingPongMessage.java (in org.openbandy.example.pingpong)
* This file is part of the OpenBandy project.
*
* www.openbandy.org
*/

package org.openbandy.example.pingpong;

import java.util.Vector;

import org.openbandy.io.Serializable;
import org.openbandy.io.SerializationBuffer;
import org.openbandy.io.SerializationIdentifiers;
import org.openbandy.io.Serializer;
import org.openbandy.log.LogImpl;

/**
 * TODO describe purpose and usage
 *
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 *
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 0.1
 * 
 */
public class PingPongMessage implements Serializable {
	
    /* Storage serializer ID */
    protected int pingPongMessageId = SerializationIdentifiers.NO_ID;
	
	private String messageString = "";
	
	private int serveCounter = 0;
	
	
	/* ***** Getter and Setter Methods ***** */

	public String getMessageString() {
		return messageString;
	}

	public void setMessageString(String messageString) {
		this.messageString = messageString;
	}

	public int getServeCounter() {
		return serveCounter;
	}

	public void setServeCounter(int serveCounter) {
		this.serveCounter = serveCounter;
	}

	/* *************** Methods for Serialization ***************** */

	public void serialize(Serializer serializer, SerializationBuffer buffer) {
		buffer.container().addString("messageString", messageString);
		buffer.container().addInt("serveCounter", serveCounter);
	}
    
	public void deserialize(Serializer serializer, SerializationBuffer buffer) {
		messageString = buffer.container().getString("messageString");
		serveCounter = buffer.container().getInt("serveCounter");
	}
	
	public String getLegibleString() {
		return messageString+LogImpl.VALUE_DELIMITER+
			   serveCounter+LogImpl.VALUE_DELIMITER;
	}
    
    public boolean isEqualShallow(Serializable serializableObject) throws ClassCastException {
        PingPongMessage comparingMessage = (PingPongMessage) serializableObject;
        return ( (this.serveCounter == comparingMessage.serveCounter) && 
                          this.messageString.equals(comparingMessage.messageString) );
    }
	
	public boolean isEqual(Serializable serializableObject) throws ClassCastException {
	    return isEqualShallow(serializableObject);
	}
	
	public String getIdName() {
		return "pingPongId";
	}
	
	public int getIdValue() {
		return SerializationIdentifiers.NO_ID;
	}
	
	public void setIdValue(int idValue) {
	    pingPongMessageId = idValue;
	}
    public void getAttributeNames(Vector attributes) {
        attributes.addElement("messageString");
        attributes.addElement("serveCounter");
    }
    public void getReferences(Vector references) {}
    public void getReferencedIdNames(Vector referenceNames) {}

    public Serializable getNewInstance() {
    	return new PingPongMessage();
    }
    
    public Serializable getCopy() {
    	PingPongMessage clone = new PingPongMessage();
        clone.messageString = this.messageString;
        clone.serveCounter = this.serveCounter;
        return clone;
    }

}
