/**
 * Filename: RemoteStoreProtocol.java (in org.openbandy.example.remotestore)
 * This file is part of the OpenBandy project.
 *
 * www.openbandy.org
 */

package org.openbandy.example.remotestore;

import org.openbandy.io.Message;
import org.openbandy.io.Serializable;
import org.openbandy.net.ServerProtocol;

/**
 * TODO describe purpose and usage
 *
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 *
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 0.1
 * 
 */
public class RemoteStoreProtocol implements ServerProtocol {


	/**
	 * TODO comment!
	 *
	 * @param sender
	 * @param objectToStoreOnServer
	 * @return
	 */
	public Message createMessage(String sender, Serializable objectToStoreOnServer){
		Message request = new Message(sender);
		request.setType(REMOTE_STORE_MESSAGE);
		request.setContent(objectToStoreOnServer);
		return request;
	}

	
	/* *********** Methods for ServerProtocol **************** */
	
	public boolean isValidMessage(Message msg) {
		if(msg != null){
			return ( (msg.getContent() != null) && (msg.getContent() instanceof Serializable) && (isValidType(msg.getType())) );
		}
		return false;
	}
	
    public int getPort(){
    	return PORT_REMOTE_STORE;
    }

	/* *********** Helper Methods **************** */

	private boolean isValidType(int type){
		switch (type) {
		case REMOTE_STORE_MESSAGE : return true;
		default : return false;
		}

	}

}
