/**
* Filename: DirectByteArrayInputStream.java (in org.openbandy.io.rms)
* This is part of the OpenBandy project.
* 
* www.openbandy.org
*/

package org.openbandy.io.rms;

import java.io.ByteArrayInputStream;

/**
* A version of ByteArrayInputStream that
* replaces the underlying byte array.
*
* <br><br>
* (c) Copyright P. Bolliger 2007, ALL RIGHTS RESERVED.
*
* @author Philipp Bolliger (philipp@bolliger.name)
* @version 1.0
*/
public class DirectByteArrayInputStream extends ByteArrayInputStream {

 // Constructs an output stream from the given array

 public DirectByteArrayInputStream( byte buf[] ){
     super( buf );
 }

 // Constructs an output stream from the given subarray

 public DirectByteArrayInputStream( byte buf[],
                                    int offset, 
                                    int length ){
     super( buf, offset, length );
 }

 // Resets the array the stream reads from

 /**
 * TODO comment!
 *
 * @param buf
 */
public synchronized void setByteArray( byte[] buf ){
     this.buf = buf;
     this.pos = 0;
     this.count = buf.length;
     this.mark = 0;
 }

 // Resets the array the stream reads from

 /**
 * TODO comment!
 *
 * @param buf
 * @param offset
 * @param length
 */
public synchronized void setByteArray( byte[] buf, 
                                        int offset,
                                        int length ){
     this.buf = buf;
     this.pos = offset;
     this.count = Math.min( offset + length, buf.length );
     this.mark = offset;
 }
}
