/**
* Filename: BandyProtocol.java (in org.openbandy.net)
* This file is part of the BandyBasics project.
*
* www.openbandy.org
*/
package org.openbandy.net;

import org.openbandy.io.Message;



/**
 * TODO describe purpose and usage
 * 
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 *
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 0.1
 * 
 */
public interface ServerProtocol {
	
    /* *********** Bandy Service port numbers ************ */
    
	public final static int PORT_PING_PONG  = 54540;
	public final static int PORT_REMOTE_STORE  = 54541;
    
    
    /* ************ Message Types *************** */
    
    /* Messages for ping pong service */
    public final static int PING_PONG_MESSAGE = 101;
    
    /* Messages for remote store service */
    public final static int REMOTE_STORE_MESSAGE = 201;
	
	/**
     * This method will test the <code>message</code> for
     * validity according to its implementation.
	 * @param message
	 * @return
	 */
	public boolean isValidMessage(Message message);
	
    /**
     * @return The port number of the service.
     */
    public int getPort();
}
