/**
* Filename: MessageScannerHelper.java (in org.openbandy.net.client)
* This file is part of the BandyBasics project.
*
* www.openbandy.org
*/

package org.openbandy.net.client;

import org.openbandy.io.Message;
import org.openbandy.service.EventService;
import org.openbandy.util.StringUtil;

/**
 * TODO describe purpose and usage
 * 
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 *
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 0.1
 * 
 */
public class MessageScannerHelper {
    
    protected static void processNewMessage(Message message){

        /* Generate IncomingMessagEvent to inform interested parties */
        IncomingMessageEvent incomingMessageEvent = new IncomingMessageEvent();
        if(message.getContent() != null){
            String contentClassName = StringUtil.getShortClassName(message.getContent());
            incomingMessageEvent.setContentClassName(contentClassName);
        }
        
        /* set message Queue ID */
        int messageQueueID = MessageBrokerImpl.incomingMessageQueue.enqueue(message);
        incomingMessageEvent.setMessageQueueId(messageQueueID);
        
        /* fire event */
        EventService.delegate(incomingMessageEvent);
    }

}
