/**
* Filename: MessageBrokerService.java (in org.openbandy.service)
* This file is part of the BandyClient project.
*
* www.BandyClient.org
*/

package org.openbandy.service;

import org.openbandy.io.Message;
import org.openbandy.net.MessageBroker;
import org.openbandy.net.ServerProtocol;
import org.openbandy.net.client.MessageBrokerImpl;

/**
 * TODO describe purpose and usage
 *
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 *
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 0.1
 * 
 */
public final class MessageService extends Service {
	
	/* static reference to the message broker used in this service */
    private static MessageBroker messageBroker;
	
	/* statically assign a message broker of type
	 * org.openbandy.net.client.MessageBrokerImpl
	 * when running on microedition */
	static{
		if(runningOnMicroEdition()){
	    	messageBroker = new MessageBrokerImpl();
	    }
	}
    
    public static void setMessageBroker(MessageBroker messageBroker){
    	MessageService.messageBroker = messageBroker;
    }
    
    public static Message sendMessage(String host, ServerProtocol protocol, Message message){
    	if(messageBroker != null){
    		return messageBroker.sendMessage(host, protocol, message);
    	}
    	else{
    		LogService.warn("MessageBrokerService", "No MessageBroker implementation set");
    		return null;
    	}
    }
    
}
