/**
 * Filename: Test.java (in org.openbandy.test)
 * This file is part of the BandyBasics project.
 *
 * www.BandyBasics.org
 */

package org.openbandy.test;

import org.openbandy.service.LogService;
import org.openbandy.ui.Tests;

/**
 * TODO describe purpose and usage
 *
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 *
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 0.1
 * 
 */
public abstract class Test implements Runnable {

	/* Name of a test, should give evidence what is tested */
	private String name = "";

	/* Callback to the tests screen, used to show progress and result */
	protected Tests testsScreen = null;

	/* The point in time when the test is started */
	protected long startTime = 0;

	/* Constructor */
	public Test(String name){
		this.name = name;
	}


	/* ***** Getter and Setter Methods ***** */

	public void setTestsScreen(Tests tests){
		this.testsScreen = tests;
	}

	public String getName(){
		return name;
	}

	/* ***** Methods to time the test ***** */

	protected void testStarted(){
		testsScreen.setTestRunning(this);
		LogService.info(this, "Started test '"+name+"'");
		startTime = System.currentTimeMillis();
	}

	protected void testFinished(){
		if(startTime > 0) {
			double duration = (System.currentTimeMillis()-startTime)/1000.0;
			LogService.info(this, "Finished test '"+name+"' after "+duration+" seconds");
		}
		else {
			LogService.info(this, "Finished test '"+name+"'");
		}
	}

	/* ***** Thread related Methods ***** */

	public void start(){		
		Thread testThread = new Thread(this);
		testThread.start();
	}

}
